diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
index b2ec41d87..86da7cdc2 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
@@ -1,20 +1,25 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ICapturable;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+
+import java.util.List;
+import java.util.Random;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 
-import java.util.List;
-
 public class ItemJar extends ItemPlaceable {
 
     protected ItemJar(@NotNull String name, @NotNull String namespaceId, int id) {
@@ -23,77 +28,83 @@ public class ItemJar extends ItemPlaceable {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        if (player != null && player.isSneaking()) {
-            return super.onUseOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
-        }
-        if (player != null) {
-            int count = selfStack.stackSize;
-            ItemStack used = onUse(selfStack, world, player);
-            if (used != null && used.stackSize != count) {
-                return true;
-            }
-        }
-        return super.onUseOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
+    public boolean interactsWithEntity(@NotNull ItemStack selfStack, @NotNull Entity entity) {
+        return super.interactsWithEntity(selfStack, entity) || (
+            entity instanceof ICapturable pokemon && pokemon.canBeCapturedBy(this)
+        );
     }
 
     @Override
-    public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
-        if (player.isSneaking()) {
-            return selfStack;
-        }
-        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(player, MathHelper.aabbGrow(player.bb, 2, 2, 2, new AABBd()));
+    public boolean useOnEntity(@NotNull ItemStack selfStack, @NotNull Player player, @NotNull Mob mob) {
+        final var captured =  this.tryCaptureEntity(selfStack, player, mob);
+        if (captured == null) return false;
+        player.inventory.insertItem(captured, true);
+        if (captured.stackSize <= 0) return true;
+        player.world.dropItem(player.x, player.y + player.bbHeight, player.z, captured, 0.0);
+        return true;
+    }
 
-        for (Entity entity : list) {
-            if (entity instanceof MobFireflyCluster fireflyCluster) {
-                MobFireflyCluster.FireflyColor colour = fireflyCluster.getColor();
+    @Override
+    public void onUseByActivator(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @NotNull TileEntityActivator activator,
+        @NotNull Random random, @NotNull TilePosc blockPos,
+        @NotNull Direction direction, double offX, double offY, double offZ
+    ) {
+        final var pos = blockPos.add(direction, new TilePos());
+        final @NotNull List<Entity> entities;
 
-                boolean didFillJar;
-                if (colour == MobFireflyCluster.FireflyColor.BLUE) {
-                    didFillJar = fillJar(player, new ItemStack(Items.LANTERN_FIREFLY_BLUE, 1));
-                } else if (colour == MobFireflyCluster.FireflyColor.ORANGE) {
-                    didFillJar = fillJar(player, new ItemStack(Items.LANTERN_FIREFLY_ORANGE, 1));
-                } else if (colour == MobFireflyCluster.FireflyColor.RED) {
-                    didFillJar = fillJar(player, new ItemStack(Items.LANTERN_FIREFLY_RED, 1));
-                } else {
-                    didFillJar = fillJar(player, new ItemStack(Items.LANTERN_FIREFLY_GREEN, 1));
-                }
+        interface ctx { AABBd bb = new AABBd(); }
+        synchronized(ctx.bb) {
+            ctx.bb.setMin(0,0,0).setMax(1,1,1).translate(pos.x(), pos.y(), pos.z());
+            entities = world.getEntitiesWithinAABBExcludingEntity(null, ctx.bb);
+        }
 
-                if (!world.isClientSide && didFillJar) {
-                    fireflyCluster.setFireflyCount(fireflyCluster.getFireflyCount() - 1);
-                    if (fireflyCluster.getFireflyCount() <= 0) {
-                        fireflyCluster.remove();
-                    }
-                }
+        boolean hasEntity = false;
+        for (final var entity : entities) {
+            if (entity instanceof ICapturable pokemon && pokemon.canBeCapturedBy(this)) {
+                final var captured = this.tryCaptureEntity(selfStack, null, entity);
+                if (captured == null) continue;
+                world.dropItem(pos, captured);
+                return;
+            }
+            if (entity.isSelectable()) hasEntity = true;
+        }
+        if (hasEntity) return;
+        super.placeWithoutShift(selfStack, world, null, pos, direction.opposite().side(), 0.5, 0.5);
+    }
 
-                return selfStack;
-            } else if (entity instanceof MobButterfly butterfly) {
-                MobButterfly.ButterflyEntry color = MobButterfly.colorEntries.get(butterfly.getColor());
+    public @Nullable ItemStack tryCaptureEntity(
+        @NotNull ItemStack selfStack,
+        @Nullable Player player, @NotNull Entity entity
+    ) {
+        if (selfStack.stackSize <= 0) return null;
+        if (entity instanceof ICapturable pokemon); else return null;
+        if (!pokemon.canBeCapturedBy(this)) return null;
 
-                boolean didFillJar = fillJar(player, new ItemStack(color.jarItem.get(), 1));
+        final int count = pokemon.onCaptured();
+        if (count == 0) return null;
 
-                if (!world.isClientSide && didFillJar) {
-                    butterfly.remove();
-                }
+        final Item resultingItem;
+        if (pokemon instanceof MobFireflyCluster firefly) resultingItem = captureFirefly(firefly);
+        else if (pokemon instanceof MobButterfly butterfly) resultingItem = captureButterfly(butterfly);
+        else return null;
 
-                return selfStack;
-            }
-        }
-        return selfStack;
+        return new ItemStack(resultingItem);
     }
 
-    public static boolean fillJar(@NotNull Player player, @NotNull ItemStack itemToGive) {
-        ItemStack currentItem = player.inventory.getCurrentItem();
-        if (currentItem == null || currentItem.stackSize <= 1) {
-            player.inventory.setItem(player.inventory.getCurrentSlot(), itemToGive);
-        } else {
-            player.inventory.insertItem(itemToGive, true);
-        }
-        if (itemToGive.stackSize < 1) {
-            player.swingItem();
-            player.inventory.getCurrentItem().consumeItem(player);
-            return true;
-        }
-        return false;
+    // TODO extensibility
+    private static @NotNull Item captureFirefly(@NotNull MobFireflyCluster firefly) {
+        final var colour = firefly.getColor();
+        if (colour == MobFireflyCluster.FireflyColor.BLUE) return Items.LANTERN_FIREFLY_BLUE;
+        if (colour == MobFireflyCluster.FireflyColor.ORANGE) return Items.LANTERN_FIREFLY_ORANGE;
+        if (colour == MobFireflyCluster.FireflyColor.RED) return Items.LANTERN_FIREFLY_RED;
+        if (colour == MobFireflyCluster.FireflyColor.GREEN) return Items.LANTERN_FIREFLY_GREEN;
+        throw new AssertionError("unreachable");
+    }
+    private static @NotNull Item captureButterfly(@NotNull MobButterfly butterfly) {
+        final var color = MobButterfly.colorEntries.get(butterfly.getColor());
+        assert color != null;
+        return color.jarItem();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
index 2625ad6ef..c9f1cd304 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -4,27 +4,20 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicOverlayPebbles;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectilePebble;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.joml.primitives.AABBd;
-import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class ItemPebble extends Item implements IDispensable {
-
+public class ItemPebble extends Item implements IDispensable, IAccumulatable<BlockLogicOverlayPebbles> {
     public ItemPebble(String name, String namespaceId, int id) {
         super(name, namespaceId, id);
-        this.maxStackSize = 64;
     }
 
     @Override
@@ -38,87 +31,50 @@ public class ItemPebble extends Item implements IDispensable {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        if (player == null) return false;
-        @NotNull Block<?> block = world.getBlockType(blockPos);
-        int meta = world.getBlockData(blockPos);
-        if (block != Blocks.OVERLAY_PEBBLES && block.hasTag(BlockTags.PLACE_OVERWRITES)) {
-            block = Blocks.AIR;
-            meta = 0;
-        }
-        if (selfStack.stackSize <= 0) {
-            return false;
-        }
-        if (blockPos.y() == world.getHeightBlocks() - 1 && Blocks.OVERLAY_PEBBLES.getMaterial().isSolid()) {
-            return false;
-        }
-
-        final var pebble = Blocks.OVERLAY_PEBBLES.getLogic();
-
-        // Check if we're placing "inside" a layer
-        if (block == Blocks.OVERLAY_PEBBLES && side == Side.TOP) {
-            final int newMeta = meta + 1;
-            if (!pebble.isSupported(world, blockPos, Side.BOTTOM)) return false;
-
-            if (newMeta < BlockLogicOverlayPebbles.MAX_PEBBLES) {
-                world.setBlockTypeDataNotify(blockPos, Blocks.OVERLAY_PEBBLES, newMeta);
-                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
-                selfStack.consumeItem(player);
-                return true;
-            }
-        }
-
-        // Offset position
-        if (block != Blocks.AIR) {
-            blockPos = blockPos.add(side.direction(), new TilePos());
-            block = world.getBlockType(blockPos);
-            meta = world.getBlockData(blockPos);
-        }
-
-        // Check if the block we're placing into is a layer
-        if (block == Blocks.OVERLAY_PEBBLES) {
-            final int newMeta = meta + 1;
-
-            final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
-            if (!world.checkIfAABBIsClear(bbBox) || !pebble.isSupported(world, blockPos, Side.BOTTOM)) {
-                return false;
-            }
+    public @NotNull Block<BlockLogicOverlayPebbles> getBlock() {
+        return Blocks.OVERLAY_PEBBLES;
+    }
 
-            if (newMeta < BlockLogicOverlayPebbles.MAX_PEBBLES) {
-                world.setBlockTypeDataNotify(blockPos, Blocks.OVERLAY_PEBBLES, newMeta);
-                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
-                selfStack.consumeItem(player);
-                return true;
-            }
+    @Override
+    public boolean onUseOnBlock(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
+    ) {
+        return this.placeOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
+    }
 
-        }
+    @Override
+    public boolean canAccumulateInto(
+        @NotNull ItemStack selfStack,
+        @NotNull Block<?> block, int data, @NotNull Side side, double xHit, double yHit
+    ) {
+        return block == Blocks.OVERLAY_PEBBLES && data < BlockLogicOverlayPebbles.MAX_PEBBLES - 1;
+    }
 
-        // Regular placement, as all else fails
-        if (world.canBlockIdBePlacedAt(Blocks.OVERLAY_PEBBLES.id(), blockPos, false, side) && pebble.isSupported(world, blockPos, Side.BOTTOM)) {
-            if (world.setBlockTypeNotify(blockPos, Blocks.OVERLAY_PEBBLES)) {
-                Blocks.OVERLAY_PEBBLES.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
-                selfStack.consumeItem(player);
-                return true;
-            }
-        }
-        return false;
+    @Override
+    public @NotNull BlockDataResult getAccumulationResult(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull BlockDataResult result
+    ) {
+        result.data += 1;
+        return result;
     }
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        ProjectilePebble projectilePebble = new ProjectilePebble(world, blockPos.x() + offX, blockPos.y() + offY, blockPos.z() + offZ);
-        projectilePebble.setHeading(direction.offsetX() * 0.6, direction.offsetY() == 0 ? 0.1 : direction.offsetY() * 0.6, direction.offsetZ() * 0.6f, 1.1F, 6F);
-        world.entityJoinedWorld(projectilePebble);
-        selfStack.stackSize -= 1;
+        if (!selfStack.consumeItem(null)) return;
+        final var pebble = new ProjectilePebble(world, blockPos.x() + offX, blockPos.y() + offY, blockPos.z() + offZ);
+        pebble.setHeading(direction.offsetX() * 0.6, direction.offsetY() == 0 ? 0.1 : direction.offsetY() * 0.6, direction.offsetZ() * 0.6f, 1.1F, 6F);
+        world.entityJoinedWorld(pebble);
     }
 
     @Override
     public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
-        if (selfStack.consumeItem(null)) {
-            ProjectilePebble projectilePebble = new ProjectilePebble(world, x, y, z);
-            projectilePebble.setHeading(direction.offsetX(), direction.offsetY() + 0.1D, direction.offsetZ(), 1.1F, 6F);
-            world.entityJoinedWorld(projectilePebble);
-        }
+        if (!selfStack.consumeItem(null)) return;
+        final var pebble = new ProjectilePebble(world, x, y, z);
+        pebble.setHeading(direction.offsetX(), direction.offsetY() + 0.1D, direction.offsetZ(), 1.1F, 6F);
+        world.entityJoinedWorld(pebble);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
index 0d190171a..c9a939d64 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
@@ -1,88 +1,51 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
-import net.minecraft.core.item.block.ItemBlock;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class ItemPlaceable extends Item {
+public class ItemPlaceable extends Item implements IPlaceable.PlaceableBlock<BlockLogic> {
 
-    public final @NotNull Block<?> blockToPlace;
+    public final @NotNull Block<?> block;
 
-    public ItemPlaceable(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<?> blockToPlace) {
-        super(name, namespaceId, id);
+    public ItemPlaceable(@NotNull NamespaceID namespaceId, @NotNull String translationKey, int id, @NotNull Block<?> blockToPlace) {
+        super(namespaceId, translationKey, id);
 
-        this.blockToPlace = blockToPlace;
+        this.block = blockToPlace;
     }
 
-    @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        if (selfStack.stackSize <= 0) {
-            return false;
-        }
-        if (ItemBlock.shouldShift(world, blockPos, this.blockToPlace)) {
-            blockPos = blockPos.add(side.direction(), new TilePos());
-        }
-        if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks()) {
-            return false;
-        }
-        if (!world.canBlockIdBePlacedAt(this.blockToPlace.id(), blockPos, false, side)) return false;
-
-        final var data = this.blockToPlace.getPlacedData(player, selfStack, world, blockPos, side, xHit, yHit);
-
-        final var pbloc = world.getBlockType(blockPos);
-        final int pdata = world.getBlockData(blockPos);
-
-        if (!world.setBlockTypeDataRaw(blockPos, this.blockToPlace, data)) return false;
-
-        if (pbloc != this.blockToPlace || pdata != data) {
-            pbloc.onRemoved(world, blockPos, pdata);
-        }
-
-        selfStack.consumeItem(player);
+    public ItemPlaceable(@NotNull String translationKey, @NotNull String namespaceId, int id, @NotNull Block<?> blockToPlace) {
+        super(translationKey, namespaceId, id);
 
-        if (player == null) {
-            this.blockToPlace.onPlacedOnSide(world, blockPos, side, xHit, yHit);
-        } else {
-            this.blockToPlace.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-        }
-
-        // TODO before or after tileentity?
-        this.blockToPlace.onPlacedByWorld(world, blockPos);
+        this.block = blockToPlace;
+    }
 
-        if (this.blockToPlace.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
-            TileEntity tileEntity = world.getTileEntity(blockPos);
-            if (tileEntity != null) {
-                tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
-            }
-        }
+    @Override
+    @SuppressWarnings("unchecked")
+    public @NotNull Block<BlockLogic> getBlock() {
+        return (Block<BlockLogic>)this.block;
+    }
 
-        // notify self change after onPlacedByMob
-        // this should fix almost all bugs related to piston intercepting placement logic,
-        // with out change to individual onPlaced<_> logics.
-        world.notifyBlockChange(blockPos, this.blockToPlace);
-        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
-        return true;
+    @Override
+    public boolean onUseOnBlock(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
+    ) {
+        return this.placeOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
     }
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        blockPos = blockPos.add(direction, new TilePos());
-        Block<?> b = world.getBlockType(blockPos);
-        if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-            onUseOnBlock(selfStack, world, null, blockPos, direction.side(), 0.5, 0.5);
-        }
+        this.placeByActivator(selfStack, world, activator, random, blockPos, direction, offX, offY, offZ);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceablePair.java b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceablePair.java
new file mode 100644
index 000000000..3827f3647
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceablePair.java
@@ -0,0 +1,157 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3i;
+
+import java.util.Random;
+
+public abstract class ItemPlaceablePair extends Item implements IPlaceable {
+
+    protected final @NotNull Block<?> blockA;
+    protected final @NotNull Block<?> blockB;
+
+    private static final PlacementResult resultBuffer = new PlacementResult();
+
+    public ItemPlaceablePair(
+        @NotNull NamespaceID namespaceId, @NotNull String translationKey, int id,
+        @NotNull Block<?> blockA, @NotNull Block<?> blockB
+    ) {
+        super(namespaceId, translationKey, id);
+        this.blockA = blockA;
+        this.blockB = blockB;
+    }
+    
+    public ItemPlaceablePair(
+        @NotNull String translationKey,@NotNull String namespaceId, int id,
+        @NotNull Block<?> blockA, @NotNull Block<?> blockB
+    ) {
+        super(translationKey, namespaceId, id);
+        this.blockA = blockA;
+        this.blockB = blockB;
+    }
+
+    protected static class PlacementResult {
+        public int dataA;
+        public int dataB;
+        public final @NotNull Vector3i offsetB = new Vector3i();
+        public boolean cannotPlace;
+    }
+
+    protected abstract @NotNull PlacementResult getPlacement(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull PlacementResult result
+    );
+
+    @Override
+    public boolean shouldShiftOutOf(
+        @NotNull ItemStack selfStack, 
+        @NotNull World world, @NotNull Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit
+    ) {
+        return IPlaceable.shouldShiftBlockOutOf(blockA, world, blockPos);
+    }
+
+    @Override
+    public boolean onUseOnBlock(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
+    ) {
+        return this.placeOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
+    }
+
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        this.placeByActivator(selfStack, world, activator, random, blockPos, direction, offX, offY, offZ);
+    }
+
+    @Override
+    public boolean placeWithoutShift(
+        @NotNull ItemStack selfStack, @NotNull World world,
+        @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit
+    ) {
+        if (selfStack.stackSize <= 0) return false;
+        if (!this.canPlaceDirectlyAtPosition(selfStack, world, player, blockPos, side, xHit, yHit)) return false;
+
+        final TilePosc posA, posB;
+        final int dataA, dataB;
+
+        synchronized (resultBuffer) {
+            resultBuffer.dataA = resultBuffer.dataB = 0;
+            resultBuffer.offsetB.set(0,0,0);
+            resultBuffer.cannotPlace = false;
+            final var result = this.getPlacement(selfStack, world, player, blockPos, side, xHit, yHit, resultBuffer);
+
+            if (result.cannotPlace) return false;
+
+            dataA = result.dataA;
+            dataB = result.dataB;
+            posA = blockPos;
+            posB = blockPos.add(result.offsetB, new TilePos());
+        }
+
+        final @Nullable Block<?> prevBlockA, prevBlockB;
+        final int prevDataA, prevDataB;
+        final boolean isAIdentical, isBIdentical;
+
+        prevBlockA = world.getBlockType(posA);
+        prevDataA = world.getBlockData(posA);
+
+        prevBlockB = world.getBlockType(posB);
+        prevDataB = world.getBlockData(posB);
+        
+        isAIdentical = prevBlockA == this.blockA && prevDataA == dataA;
+        isBIdentical = prevBlockB == this.blockB && prevDataB == dataB;
+        
+        if (!isAIdentical) world.setBlockTypeDataRaw(posA, this.blockA, dataA);
+        if (!isBIdentical) world.setBlockTypeDataRaw(posB, this.blockB, dataB);
+        if (!isAIdentical) world.markBlockNeedsUpdate(posA);
+        if (!isBIdentical) world.markBlockNeedsUpdate(posB);
+
+        if (!isAIdentical) prevBlockA.onRemoved(world, posA, prevDataA);
+        if (!isBIdentical) prevBlockB.onRemoved(world, posB, prevDataB);
+        if (player == null) {
+            if (!isAIdentical) this.blockA.onPlacedOnSide(world, posA, side, xHit, yHit);
+            if (!isBIdentical) this.blockB.onPlacedOnSide(world, posB, side, xHit, yHit);
+        } else {
+            if (!isAIdentical) this.blockA.onPlacedByMob(world, posA, side, player, xHit, yHit);
+            if (!isBIdentical) this.blockB.onPlacedByMob(world, posB, side, player, xHit, yHit);
+        }
+        if (!isAIdentical) this.blockA.onPlacedByWorld(world, posA);
+        if (!isBIdentical) this.blockB.onPlacedByWorld(world, posB);
+
+        if (this.blockA.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
+            final var tileEntity = world.getTileEntity(blockPos);
+            if (tileEntity != null) {
+                tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
+            }
+        }
+        if (isAIdentical != isBIdentical) {
+            if (isAIdentical) world.notifyBlocksOfNeighborChange(posB, this.blockB);
+            else world.notifyBlocksOfNeighborChange(posA, this.blockA);
+        } else if (isAIdentical) {
+            assert isBIdentical;
+            world.notifyBlocksOfNeighborChanges(new TilePosc[] { posA, posB }, null);
+        }
+        world.playBlockSoundEffect(
+            player,
+            posA.x() + 0.5F, posA.y() + 0.5F, posA.z() + 0.5F,
+            this.blockA, EnumBlockSoundEffectType.PLACE
+        );
+        return true;
+    }
+}
